//
// "$Id: CoolInput.h 2006-11-27 07:46:00 Dmitry Perov [gentooshnik@rambler.ru] $"
//
// Copyright 1998-2006 by Bill Spitzak and others.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
//
// Please report all bugs and problems to "fltk-bugs@fltk.org".

#ifndef fltk_CoolInput_h
#define fltk_CoolInput_h 1

#include <fltk/PopupMenu.h>
#include <fltk/Item.h>
#include <fltk/Divider.h>
#include <fltk/Group.h>
#include <fltk/xpmImage.h>
#include <fltk/Color.h>
#include <fltk/Input.h>
#include <fltk/events.h>
#include <fltk/Cursor.h>
#include <fltk/Font.h>
#include <fltk/Style.h>


namespace fltk {

enum {
LANG_EN = 0,
LANG_RU = 1
};

class FL_API  CoolInput : public Input {

public:

CoolInput(int x, int y, int w, int h, const char* label = 0, const int lang = LANG_EN, Cursor* c = CURSOR_INSERT);

~CoolInput();

/** without author style popup menu */
void style_fltk();

void set_color_popup(const Color c);
void set_text_color_popup(const Color c);
void set_selection_color_popup(const Color c);
void set_selection_textcolor_popup(const Color c);
void set_textsize_popup(const int sz);
void set_font_popup(Font *f);
void set_box_style_popup(Box *b);
void set_lang_popup(const int lng);
int lang_popup() const;

void _paste(int, CoolInput* c);
int handle(int);

Cursor* cursor;
PopupMenu *pm;
Item *il_cut;
Item *il_copy;
Item *il_paste;
Item *il_select;
Item *il_unselect;
Item *il_cleanse;
xpmImage *img_cut;
xpmImage *img_copy;
xpmImage *img_paste;
Color color_popup;
Color text_color_popup;
Color selection_color_popup;
Color selection_textcolor_popup;
int textsize_popup;
Font *font_popup;
Box *bs;

private:
void init_menu();
void init_style();
int _Lang;
bool style_off;
};

}

#endif
